<?php
/*
Simple:Press Plugin Title: Editor QuickTags HTML
Version: 1.2.2
Plugin URI: http://simple-press.com
Description: HTML Editor using QuickTags
Author: Andy Staines & Steve Klasen
Author URI: http://simple-press.com
Simple:Press Versions: 5.2.3 and above
$LastChangedDate: 2013-03-04 12:49:15 -0700 (Mon, 04 Mar 2013) $
$Rev: 9956 $
*/

if (preg_match('#'.basename(__FILE__).'#', $_SERVER['PHP_SELF'])) die('Access denied - you cannot directly call this file');

# ======================================
# EDITOR CONSTANTS
#	Must be one of:
#	RICHTEXT 	- 1
#	HTML		- 2
#	BBCODE		- 3
# ======================================
define('HTML',			2);
define('HTMLNAME',		'QuickTags');

# ======================================
# CONSTANTS USED BY THIS PLUGIN
# ======================================
define('SPQTHDIR',		SFPLUGINDIR.'quicktags-html/');
define('SPQTHEDSCRIPT',	SFPLUGINURL.'quicktags-html/qthtml/');
define('SPQTHRESOURCES',SFPLUGINURL.'quicktags-html/resources/');

# ======================================
# ACTIONS/FILTERS USED BY THUS PLUGIN
# ======================================
add_action('sph_activate_quicktags-html/sp-qthtml-plugin.php',		'sp_qthtml_install');
add_action('init',													'sp_qthtml_localisation');
add_action('sph_load_editor_support', 								'sp_qthtml_load_filters', 1, 1);
add_action('sph_load_editor',										'sp_qthtml_load');
add_filter('sph_editor_textarea',									'sp_qthtml_textarea', 1, 5);
add_filter('sph_ProfilePostingOptionsFormEditors',					'sp_qthtml_profile_option', 1, 2);

# ======================================
# CONTROL FUNCTIONS USED BY THUS PLUGIN
# ======================================

# ----------------------------------------------
# Run Install Script on Activation action
# ----------------------------------------------
function sp_qthtml_install() {
	include_once(SPQTHDIR.'sp-qthtml-install.php');
	sp_qthtml_do_install();
}

# ----------------------------------------------
# Set GetText Localisation Domain
# ----------------------------------------------
function sp_qthtml_localisation() {
	sp_plugin_localisation('sp-qthtml');
}

# ----------------------------------------------
# Load the qt html filter file
# ----------------------------------------------
function sp_qthtml_load_filters($editor) {
	if ($editor == HTML) {
		include_once(SPQTHDIR.'library/sp-qthtml-filters.php');
	}
}

# ----------------------------------------------
# Load and Initialise this Editor if needed
# ----------------------------------------------
function sp_qthtml_load($editor) {
	if ($editor == HTML) {
		include_once(SPQTHDIR.'qthtml/sp-qthtml-init.php');
	}
}

# ----------------------------------------------
# Display Textarea Input control
# ----------------------------------------------
function sp_qthtml_textarea($out, $areaid, $content, $editor, $tab) {
	if ($editor == HTML) {
		$out.= '<div id="spQuickTags">'."\n";
		$out.= '<img class="spRight" src="'.SPQTHRESOURCES.'images/qthtml.gif" alt="" />';
		$out.= '<div id="ed_toolbar" class="editor_toolbar"></div>';
		$out.= '<script type="text/javascript">edToolbar();</script><textarea class="spQtEditor spControl spLeft" name="'.$areaid.'" id="'.$areaid.'" rows="12">'.$content.'</textarea>';
		$out.= '<script type="text/javascript">var edCanvas = document.getElementById("'.$areaid.'");</script>'."\n";
		$out.= '</div>'."\n";
		$out.= '<div class="spClear"></div>';
	}
	return $out;
}

# ----------------------------------------------
# Add HTML to user profile editor option list
# ----------------------------------------------
function sp_qthtml_profile_option($edOpts, $userProfile) {
	$checked = ($userProfile->editor == HTML) ? $checked = 'checked="checked" ' : '';
	$edOpts.= '<p class="spProfileRadioLabel"><label for="sf-html"><span>'.__("HTML", 'sp-qthtml').' - '.HTMLNAME.'</span></label><input type="radio" '.$checked.'name="editor" id="sf-html" value="'.HTML.'"/></p>';
	return $edOpts;
}

?>